%define anolis_release 4

Name:           perl-Object-HashBase
Version:        0.009
Release:        %{anolis_release}%{?dist}
Summary:        Build hash-based classes
License:        GPL+ or Artistic
URL:            https://metacpan.org/release/Object-HashBase

Source0:        https://cpan.metacpan.org/authors/id/E/EX/EXODIST/Object-HashBase-%{version}.tar.gz

BuildArch:      noarch
BuildRequires:  make
BuildRequires:  perl-generators perl-interpreter perl(:VERSION) >= 5.8.1
BuildRequires:  perl(strict) perl(warnings) perl(ExtUtils::MakeMaker) >= 6.76
# Run-time:
BuildRequires:  perl(base) perl(Carp) perl(Test::More) >= 0.98 perl(vars)
# Tests:
BuildRequires:  perl(File::Temp)

# Remove under-specified dependenices and private modules
%global __requires_exclude %{?__requires_exclude:%{__requires_exclude}|}^perl\\(Test::More\\)$
%global __requires_exclude %{__requires_exclude}|^perl\\(Object::HashBase::Test::HBase.*

%description
%{name} is used to generate classes based on hash references. Using this class
will give you a new() method, as well as generating accessors you request.
Generated accessors will be getters, set_ACCESSOR setters will also be
generated for you. You also get constants for each accessor (all caps) which
return the key into the hash for that accessor. Single inheritance is also
supported.

%package tools
Summary:        Generate inlined Object::HashBase Perl module
Requires:       %{name} = %{version}-%{release}
Requires:       perl(Test::More) >= 0.98

%description tools
hashbase_inc.pl script generates a Perl module that contains a Object::HashBase
module mangled into a name space of your choice. It can also generate the tests
for it.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n Object-HashBase-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}

%install
%{make_install}
%{_fixperms} $RPM_BUILD_ROOT/*

%check
make test

%files
%license LICENSE
%{perl_vendorlib}/*
%{_mandir}/man3/*
%exclude %{perl_vendorlib}/Object/HashBase
%exclude %{_mandir}/man3/Object::HashBase::*

%files tools
%{_bindir}/hashbase_inc.pl
%{perl_vendorlib}/Object/HashBase
%{_mandir}/man3/Object::HashBase::*

%files doc
%doc Changes README

%changelog
* Thu Apr 13 2023 Jing Zhang <renyu.zj321357@linux.alibaba.com> - 0.009-4
- Refact spec

* Mon Feb 06 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.009-3
- remove versioned MODULE_COMPAT_ requires

* Mon Jan 30 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 0.009-2
- rebuild with perl 5.36.0

* Thu Apr 21 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.009-1
- Init from upstream version 0.009

